// EX1_01.CPP
// A Simple Example of a Program
#include <iostream>
#include <iomanip>
using namespace std;

int main()
{
   int apples, oranges;        // Declare two integer variables
   int fruit;                  // ...then another one
   bool supMMX = true;		// variable for testing MMX technology
   bool supSSE = true;		// variable for testing SSE tech
   bool supSSE2 = true;		// var for SSE2 tech
// these bools are all BYTE PTRs in Assembly Language.

// addition of two integer arrays with MMX (and SSE2)
   int a1[] = {130, 111, 142, 413, 314, 115, 176, 917};
   int b1[] = {105, 991, 809, 107, 968, 553, 847, 431};
   int c1[8];
   int asize = sizeof(a1)/4;	// # of variables in a1 (8)
   
// display both arrays to be added on screen.
    cout << "a1: ";
	for (int cnt = 0; cnt < asize; cnt++)
		cout << a1[cnt] << " ";
	cout << endl;

	cout << "b1: ";
	for (int cnt2 = 0; cnt2 < asize; cnt2++)
		cout << setw(2) << b1[cnt2] << " ";
	cout << endl;

// remember F7 to Compile, CTRL-F5 to Execute, 
// CTRL-F10 Debug run to cursor.
   
   _asm {
		mov supMMX, 1
		mov EAX, 1
		cpuid
		test EDX, 0x800000
		jnz sup
		mov supMMX, 0
sup:
		mov supSSE, 1
		mov EAX, 1
		cpuid
		test EDX, 0x2000000
		jnz found
		mov supSSE, 0
found:
		mov supSSE, 1
		mov EAX, 1
		cpuid
		test EDX, 0x4000000
		jnz found2
		mov supSSE2, 0
found2:
   }
   apples = 5; oranges = 6;    // Set initial values
   fruit = apples + oranges;   // Get the total fruit

   cout << endl;               // Start output on a new line
   cout << "Oranges are not the only fruit... " << endl
        << "- and we have " << fruit << " fruits in all.";
   cout << endl << endl << endl << endl;               // Start output on a new line
   cout << "     MMX *--* SSE *--* SSE2" << endl;
   cout << "*------------------------------*" << endl;
   cout << "     Technology Analysis" << endl;
   cout << "*------------------------------*" << endl;
   cout << "  and Experiments by Jeff C" << endl << endl << endl;

   // display results of MMX CPUID test
   if (supMMX)
	   cout << "MMX Extensions" << endl;
   else
		cout << "NO MMX" << endl;

   // display results of SSE CPUID test
   if (supSSE)
	   cout << "SSE Extensions" << endl;
   else
	   cout << "NO SSE" << endl;

   // display results of SSE2 CPUID test
   if (supSSE2)
	   cout << "SSE2 Extensions POWERHOUSE!!!!!" << endl;
   else
	   cout << "NO SSE2" << endl;

   _asm {
		lea esi, dword ptr a1
		lea edi, dword ptr b1
		lea edx, dword ptr c1
		mov ecx, 4
howard_the_duck:
		movq mm0, qword ptr [esi]
		movq mm1, qword ptr [edi]
		paddd mm0, mm1
		movq dword ptr [edx], mm0
		add esi, 8
	    add edi, 8
		add edx, 8
		loop howard_the_duck
		emms
   }

// display destination array
    cout << "c1: ";
	for (int cnt3 = 0; cnt3 < asize; cnt3++)
		cout << c1[cnt3] << " ";
	cout << endl;

   cin >> fruit;
   return 0;                   // Exit the program
}
